-- Copyright (C) 2009 Emil Axelsson <emax@chalmers.se>
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

-- |
-- Copyright  : Copyright (C) 2009 Emil Axelsson <emax@chalmers.se>
-- License    : GNU GPL, version 2 or above
--
-- Maintainer : Emil Axelsson <emax@chalmers.se>
--
-- A UTF8-friendly wrapper around (the needed part of) the @System.Directory@
-- API. @System.Directory@ works with byte-oriented strings, so in order to make
-- something user-presentable from them, they must be decoded.

module Directory where



import Control.Monad
import qualified System.Directory as Dir

import Codec.Binary.UTF8.String



getCurrentDirectory = liftM decodeString Dir.getCurrentDirectory

setCurrentDirectory = Dir.setCurrentDirectory . encodeString

doesFileExist = Dir.doesFileExist . encodeString

doesDirectoryExist = Dir.doesDirectoryExist . encodeString

getDirectoryContents =
    liftM (map decodeString) . Dir.getDirectoryContents . encodeString

removeFile = Dir.removeFile . encodeString

